import java.util.List;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Response;

import org.glassfish.jersey.media.multipart.MultiPartFeature;

import EdFi.Rest.Models.*;
import EdFi.Rest.Sdk.BearerTokenAuthenticator;
import EdFi.Rest.Sdk.CertificateValidationDisabler;
import EdFi.Rest.Sdk.RestApiTokenRetriever;
import EdFi.Rest.Sdk.RestResponse;
import EdFi.Rest.Sdk.TokenRetriever;
import EdFi.Rest.Api.*;

public class ConsoleApp {

	private static WebTarget target;  
	
	public static void main(String[] args) {
		// Trust all SSL certs -- needed unless signed SSL certificates are configured.
		CertificateValidationDisabler.disable();  // generated helper class

		// Oauth configuration
		String oauthUrl = "https://tn-rest-admin-production.cloudapp.net";
		String clientKey = "1VSqxR1M9r4F";
		String clientSecret = "UxCi8RT7WTSRaFX8EC73In1h";

		// TokenRetriever makes the oauth calls
		TokenRetriever tokenRetriever = new RestApiTokenRetriever(oauthUrl, clientKey, clientSecret);

		// JAX-RS dependency, installed via Maven
		ClientBuilder clientBuilder = ClientBuilder.newBuilder().register(MultiPartFeature.class);
		Client client = clientBuilder.build().register(new BearerTokenAuthenticator(tokenRetriever));
		
		target = client.target("https://tn-rest-production.cloudapp.net/api/v1.0");

		String uniqueId = CreateUniqueId();
		
		System.out.println(uniqueId);

        GetUniqueIdById(uniqueId);
        GetUniqueIdByExample();
	}
	
	private static String CreateUniqueId() {
		IdentitiesApi api = new IdentitiesApi(target);
		Identity identity = new Identity();
		
		identity.setBirthGender("Male");
		identity.setBirthDate("2001/01/05");
		identity.setFamilyNames("Jones");
		identity.setGivenNames("John");

        RestResponse<Identity> response = api.postIdentity(identity);

        int httpReponseCode = response.getStatus(); // should be System.Net.HttpStatusCode.OK

        System.out.println("Response code is " + httpReponseCode);

        return response.readEntity().getUniqueId();
	}
	
	private static void GetUniqueIdById(String uniqueId) {
		IdentitiesApi api = new IdentitiesApi(target);

        RestResponse<Identity> response = api.getIdentitiesById(uniqueId);
        Identity identity = response.readEntity();
        int httpReponseCode = response.getStatus(); // should be System.Net.HttpStatusCode.OK

        System.out.println("Response code is " + httpReponseCode);
        System.out.println("Name is " + identity.getGivenNames() + " " + identity.getFamilyNames());
	}
	
	private static void GetUniqueIdByExample() {
		IdentitiesApi api = new IdentitiesApi(target);
		Identity identity = new Identity();
		
		identity.setBirthGender("Male");
		identity.setFamilyNames("Jones");
		identity.setGivenNames("John");
		// Mix up the month and day on purpose.
		identity.setBirthDate("2002/05/01");

		RestResponse<List<Identity>> response = api.getIdentitiesByExample(identity);
        int httpReponseCode = response.getStatus(); // should be System.Net.HttpStatusCode.OK

        System.out.println("Response code is " + httpReponseCode);

        for (Identity id : response.readEntity())
        {
        	System.out.format("Unique Id - %s %s %s %s %s\n", id.getUniqueId(), id.getFamilyNames(), id.getGivenNames(), id.getBirthDate(), id.getWeight());
        }
	}
}