package EdFi.Rest.Api;

import javax.ws.rs.client.Entity;
import javax.ws.rs.client.Invocation.Builder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;

import org.glassfish.jersey.media.multipart.FormDataMultiPart;

import EdFi.Rest.Models.Upload;
import EdFi.Rest.Sdk.RestResponse;

public class UploadsApi {
	private final WebTarget baseTarget;
	  
    public UploadsApi(WebTarget baseTarget) {
        this.baseTarget = baseTarget;
    }
    
    @SuppressWarnings("rawtypes")
	public RestResponse postUploads(Upload body) {
        WebTarget target = baseTarget.path("/uploads/{uploadId}/chunk/{offset}/{size}");

        target = target.resolveTemplate("uploadId", body.getId());
        target = target.resolveTemplate("offset", body.getOffset());
        target = target.resolveTemplate("size", body.getSize());
     
        FormDataMultiPart multipart = new FormDataMultiPart();
        
        try {
            	multipart.bodyPart(body.getFileBytes(), MediaType.MULTIPART_FORM_DATA_TYPE);
        
        	return new RestResponse(target.request().post(Entity.entity(multipart, multipart.getMediaType()))) {};
        
        } catch (IllegalAccessError e) {
    		// *****************  not for production

        	System.out.println("error");
        	return null;
        }
    }
    
    public RestResponse<Upload> commitUploads(Upload upload) {
        WebTarget target = baseTarget.path("/uploads/{uploadId}/commit");

        // verify required params are set
        if (upload.getId() == null ) {
            throw new IllegalArgumentException("API method call is missing required parameters");
        }
        target = target.resolveTemplate("uploadId", upload.getId());
        Builder builder = target.request();
        return new RestResponse<Upload>(builder.method("POST", Entity.json(upload))) {};
    }
}
